#if !defined(AFX_CLIENT_H__E2CFA03B_14E0_46B4_9E6C_09C415A4AF78__INCLUDED_)
#define AFX_CLIENT_H__E2CFA03B_14E0_46B4_9E6C_09C415A4AF78__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Client.h : wb_[ t@C
//
#define	WM_SOCKETEVENT	WM_USER+1
enum {
	MMSO_STATUS,
	MMSO_CLOSE,
};

class CRPClientApp;

/////////////////////////////////////////////////////////////////////////////
// CTcpFifo class
//---------------------------------------------------------------------------
#define TCPFIFOMAX  128
#pragma pack(push, 1)
typedef struct {        // {ʐM\
	BYTE    ID;
	BYTE    Type;
	BYTE    len;
	BYTE    Data[8];
}TCPD;
#pragma pack(pop)
enum {
	cmdPutChar,
	cmdPTT,
	cmdPolling,
};
enum {
	retInit,
	retBusy,
	retChar,
	retFreq,
};
void __fastcall MakeTCPD(TCPD *tp, int Type, void *bp, int n);
///---------------------------------------------------------
///  oCiehen
class CTcpFifo
{
private:
	TCPD    Slot[TCPFIFOMAX];
	TCPD    *tp;
	BYTE    *wp;
	int     WL;
	int     RL;
	int     Len;
	int     Mode;
	int     Line;
	int		Err;
public:
	CTcpFifo(void);
	~CTcpFifo(void);
	inline int __fastcall GetErr(void){return Err;};
	void __fastcall Reset(void);
	void __fastcall WriteByte(BYTE c);
	void __fastcall WriteString(LPCSTR sp);
	void __fastcall Write(const BYTE *sp, int n);
	inline int __fastcall GetLine(void){return Line;};
	TCPD* __fastcall GetData();
};
//---------------------------------------------------------------------------
#define	BFIFOMAX	256
class CFifo
{
private:
	int		m_rc;
	int		m_wc;
	int		m_cc;
	BYTE	m_bf[BFIFOMAX];
	int		m_BusyLimit;

public:
	CFifo(void){
		m_cc = m_rc = m_wc = 0;
		m_BusyLimit = BFIFOMAX / 2;
	};
	void __fastcall Clear(void){
		m_cc = m_rc = m_wc = 0;
	};
	void __fastcall PutData(BYTE c){
		m_bf[m_wc] = c;
		m_wc++;
		if( m_wc >= BFIFOMAX ) m_wc = 0;
		m_cc++;
	};
	BYTE __fastcall GetData(void){
		BYTE c = m_bf[m_rc];
		m_rc++;
		if( m_rc >= BFIFOMAX ) m_rc = 0;
		m_cc--;
		return c;
	};
	int __fastcall GetCount(void){
		return m_cc;
	}
	int __fastcall IsBusy(void){
		return (m_cc < m_BusyLimit) ? FALSE : TRUE;
	}
};

/////////////////////////////////////////////////////////////////////////////
// CClient R}h ^[Qbg

class CClient : public CSocket
{
	DECLARE_DYNAMIC(CClient);

private:
	CRPClientApp	*m_pApp;
	BOOL			m_EnabledEvent;
// Agr[g
public:
// Iy[V
public:
	CClient(CRPClientApp *pApp);
	inline void EnableEvent(BOOL enabled){m_EnabledEvent = enabled;};

// I[o[Ch
public:
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CClient)
	public:
	virtual void OnReceive(int nErrorCode);
	virtual void OnClose(int nErrorCode);
	//}}AFX_VIRTUAL

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CClient)
		//  - ClassWizard ͂̈ʒuɃo֐ǉ܂͍폜܂B
	//}}AFX_MSG

// Cve[V
protected:
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_CLIENT_H__E2CFA03B_14E0_46B4_9E6C_09C415A4AF78__INCLUDED_)
