#if !defined(AFX_COMM_H__CBD2F8CF_7475_4B87_B7DD_957963631EB9__INCLUDED_)
#define AFX_COMM_H__CBD2F8CF_7475_4B87_B7DD_957963631EB9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//---------------------------------------------------------------------------
#define	USE_POLLING		TRUE
#define	WM_COMMEVENT	WM_USER+400
//---------------------------------------------------------------------------
#define	BFIFOMAX	128
class CFifo
{
private:
	LONG	m_rc;
	LONG	m_wc;
	LONG	m_cc;
	BYTE	m_bf[BFIFOMAX];

public:
	CFifo(void);
	void __fastcall Clear(void);
	void __fastcall PutData(BYTE c);
	BYTE __fastcall GetData(void);
	LPBYTE __fastcall GetP(void){return &m_bf[m_rc];};
	int __fastcall GetCount(void);
	inline int __fastcall IsBufferFull(void){return (m_cc >= BFIFOMAX);};
};
//---------------------------------------------------------------------------
class CCommPara{
public:
	CString		m_Name;
	int			m_Baud;
	int			m_Length;
	int			m_Stop;
	int			m_Parity;
	int			m_Flow;
	int			m_PTT;
public:
	CCommPara(void);

	void __fastcall LoadProfile(CWinApp *pApp);
	void __fastcall SaveProfile(CWinApp *pApp);
};
//---------------------------------------------------------------------------
class CComm
{
#if !USE_POLLING
	friend VOID WINAPI FileIOCompletionTX(DWORD fdwError, DWORD cbTransferred, LPOVERLAPPED lpo);
	friend VOID WINAPI FileIOCompletionRX(DWORD fdwError, DWORD cbTransferred, LPOVERLAPPED lpo);
#endif
	friend UINT CommThreadProc(LPVOID pParam);

private:
	CWinThread	*m_pThread;
	BOOL		m_Terminated;

#if !USE_POLLING
	OVERLAPPED	m_OverlapRX;
	OVERLAPPED	m_OverlapTX;
	BYTE		m_TxD;
	BYTE		m_RxD;
#endif
	CFifo		m_FifoRX;
	CFifo		m_FifoTX;

	HWND		m_hWnd;
	HANDLE		m_hPort;
	DCB			m_dcb;

	const CCommPara	*m_pPara;

private:
	void __fastcall ClearBuffer(void);
public:
	CComm();
	~CComm();

	BOOL __fastcall Open(HWND hWnd, const CCommPara *pPara);
	void __fastcall Close(void);

	void __fastcall SetPTT(int sw);
	void __fastcall PutChar(BYTE c);
	BYTE __fastcall GetChar(void);
	int __fastcall GetRxLen(void);
};
//---------------------------------------------------------------------------
#endif // !defined(AFX_COMM_H__CBD2F8CF_7475_4B87_B7DD_957963631EB9__INCLUDED_)
