// WLDialog.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "RPClient.h"
#include "RPDialog.h"
#include "ColorStatic.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRPDialog _CAO


CRPDialog::CRPDialog(CWnd* pParent /*=NULL*/, CRPClientApp *pApp)
	: CDialog(CRPDialog::IDD, pParent)
{
	m_pApp = pApp;
	m_nTimerID = 0;
	m_pFont = NULL;
	m_Japanese = ((GetThreadLocale() & 0x00ff) == LANG_JAPANESE);

	//{{AFX_DATA_INIT(CRPDialog)
	m_AutoConnect = FALSE;
	m_ServerName = _T("");
	//}}AFX_DATA_INIT
}


void CRPDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRPDialog)
	DDX_Control(pDX, IDC_BCONNECT, m_BConnect);
	DDX_Check(pDX, IDC_ACONNECT, m_AutoConnect);
	DDX_Text(pDX, IDC_EDITSERVER, m_ServerName);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_STATUS, m_Status);
}


BEGIN_MESSAGE_MAP(CRPDialog, CDialog)
	//{{AFX_MSG_MAP(CRPDialog)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BCONNECT, OnBconnect)
	ON_BN_CLICKED(IDC_ACONNECT, OnAconnect)
	ON_BN_CLICKED(IDC_MINIMIZE, OnMinimize)
	ON_EN_CHANGE(IDC_EDITSERVER, OnChangeEditserver)
	//}}AFX_MSG_MAP
    ON_MESSAGE(WM_SOCKETEVENT, OnSocketEvent)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
LRESULT CRPDialog::OnSocketEvent(WPARAM wParam, LPARAM lParam)
{
	ASSERT(m_pApp);
	if( !m_pApp ) return FALSE;
	return m_pApp->OnSocketEvent(wParam, lParam);
}
//---------------------------------------------------------------------------
BOOL CRPDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();

	if( m_Japanese ){
		CEdit *pEdit = (CEdit *)GetDlgItem(IDC_EDITSERVER);
		ASSERT(pEdit);

		LOGFONT	logfont;
		pEdit->GetFont()->GetLogFont(&logfont);
		logfont.lfCharSet = SHIFTJIS_CHARSET;
		m_pFont = new CFont;
		ASSERT(m_pFont);
		m_pFont->CreateFontIndirect(&logfont);
		pEdit->SetFont(m_pFont);
	}	
	m_nTimerID = SetTimer(1, WTIMERINTERVAL, NULL);
	return TRUE;
}
//---------------------------------------------------------------------------
BOOL CRPDialog::DestroyWindow() 
{
	if( m_nTimerID ){
		KillTimer(m_nTimerID);
		m_nTimerID = 0;
	}
	if( m_pFont ){
		m_pFont->DeleteObject();
		delete m_pFont;
		m_pFont = NULL;
	}
	return CDialog::DestroyWindow();
}
//---------------------------------------------------------------------------
void CRPDialog::UpdateStatus(LPCSTR pStatus, COLORREF col)
{
	m_Status.SetWindowText(pStatus, col);
}
//---------------------------------------------------------------------------
void CRPDialog::UpdateButton(BOOL enabled)
{
	m_BConnect.EnableWindow(enabled);
}
//---------------------------------------------------------------------------
void CRPDialog::GetServerName(CString &name)
{
	UpdateData(TRUE);
	name = m_ServerName;
}
//---------------------------------------------------------------------------
void CRPDialog::WindowControl(LPRECT pRect, int cmd)
{
	if( (pRect->left < -200) || (pRect->left > 2048) ) pRect->left = 0;
	if( (pRect->top < -100) || (pRect->left > 2048) ) pRect->top = 0;
	::SetWindowPos(m_hWnd, HWND_TOPMOST, pRect->left, pRect->top, 0, 0, SWP_NOSIZE);
	ShowWindow(cmd);
}
//---------------------------------------------------------------------------
BOOL CRPDialog::IsAutoConnect(void)
{
	return m_AutoConnect;
}
//---------------------------------------------------------------------------
void CRPDialog::OnTimer(UINT nIDEvent) 
{
	if( nIDEvent == m_nTimerID ){
		ASSERT(m_pApp);
		m_pApp->OnTimer();
	}
	CDialog::OnTimer(nIDEvent);
}
//---------------------------------------------------------------------------
void CRPDialog::OnBconnect() 
{
	ASSERT(m_pApp);
	m_pApp->ReqConnect();
}
//---------------------------------------------------------------------------
void CRPDialog::OnAconnect() 
{
	UpdateData(TRUE);
	PostMessage(WM_SOCKETEVENT, MMSO_STATUS, 0);
}
//---------------------------------------------------------------------------
void CRPDialog::OnMinimize() 
{
	ShowWindow(SW_MINIMIZE);
}
//---------------------------------------------------------------------------
void CRPDialog::OnChangeEditserver() 
{
	ASSERT(m_pApp);
	m_pApp->ReqDisconnect();
}
